﻿using Microsoft.Build.Framework;
using System.Collections;

namespace MsdnMag.Exchange.PushNotificationClient
{
    /// <summary>
    /// Provides a mock build engine implementation to allow calling MSBuild tasks from outside of MSBuild, like
    /// in general applications or in unit tests.
    /// </summary>
    internal class BuildEngine : IBuildEngine
    {

        #region IBuildEngine Members

        public bool BuildProjectFile(string projectFileName, string[] targetNames, IDictionary globalProperties, IDictionary targetOutputs)
        {
            return true;
        }

        public int ColumnNumberOfTaskNode
        {
            get { return 0; }
        }

        public bool ContinueOnError
        {
            get { return true; }
        }

        public int LineNumberOfTaskNode
        {
            get { return 0; }
        }

        public void LogCustomEvent(CustomBuildEventArgs e)
        {
        }

        public void LogErrorEvent(BuildErrorEventArgs e)
        {
            PushNotificationClient.WriteEventToLog(string.Format("[ERROR]: {0}", e.Message));
        }

        public void LogMessageEvent(BuildMessageEventArgs e)
        {
            PushNotificationClient.WriteEventToLog(string.Format("[INFO]: {0}", e.Message));
        }

        public void LogWarningEvent(BuildWarningEventArgs e)
        {
            PushNotificationClient.WriteEventToLog(string.Format("[WARNING]: {0}", e.Message));
        }

        public string ProjectFileOfTaskNode
        {
            get { return string.Empty; }
        }

        #endregion
    }
}