﻿using System;
using System.Collections.Generic;
using System.Text;

namespace MsdnMag.Exchange.PushNotificationClient
{
    internal static class PropertyParser
    {
        // Fields
        private static char _fieldSeperator = ';';
        private static char _valueSeperator = '=';

        // Methods
        internal static Dictionary<string, string> GetTable(string propertyList)
        {
            Dictionary<string, string> dictionary = null;
            if (propertyList != null)
            {
                dictionary = new Dictionary<string, string>(StringComparer.OrdinalIgnoreCase);
                string str = string.Empty;
                string[] strArray = propertyList.Split(new char[] { _fieldSeperator }, StringSplitOptions.RemoveEmptyEntries);
                if (strArray == null)
                {
                    return dictionary;
                }
                foreach (string str2 in strArray)
                {
                    int index = str2.IndexOf(_valueSeperator);
                    if (index != -1)
                    {
                        string str3 = str2.Substring(0, index).Trim();
                        string str4 = str2.Substring(index + 1).Trim();
                        if ((str3.Length == 0) || (str4.Length == 0))
                        {
                            throw new Exception("Invalid WorkItem Property.");
                        }
                        str = str3;
                        dictionary[str3] = str4;
                    }
                    else
                    {
                        if (string.IsNullOrEmpty(str))
                        {
                            throw new Exception("Invalid WorkItem Property.");
                        }
                        dictionary[str] = new StringBuilder(dictionary[str]).Append(_fieldSeperator).Append(str2.Trim()).ToString();
                    }
                }
            }
            return dictionary;
        }
    }
}
